[GTK][CMake] Make gtk-unix-print a component of FindGTK.cmake
[WebKit-https.git] / Source / cmake / OptionsGTK.cmake
1 include(GNUInstallDirs)
2 include(VersioningUtils)
3
4 WEBKIT_OPTION_BEGIN()
5 WEBKIT_OPTION_DEFINE(USE_GTK4 "Whether to enable usage of GTK4 instead of GTK3." PUBLIC OFF)
6
7 SET_PROJECT_VERSION(2 29 0)
8
9 if (USE_GTK4)
10     set(WEBKITGTK_API_VERSION 5.0)
11     set(GTK_MINIMUM_VERSION 3.98.2)
12     CALCULATE_LIBRARY_VERSIONS_FROM_LIBTOOL_TRIPLE(WEBKIT 0 0 0)
13 else ()
14     set(WEBKITGTK_API_VERSION 4.0)
15     set(GTK_MINIMUM_VERSION 3.22.0)
16     CALCULATE_LIBRARY_VERSIONS_FROM_LIBTOOL_TRIPLE(WEBKIT 82 0 45)
17 endif ()
18
19 CALCULATE_LIBRARY_VERSIONS_FROM_LIBTOOL_TRIPLE(JAVASCRIPTCORE 35 0 17)
20
21 # These are shared variables, but we special case their definition so that we can use the
22 # CMAKE_INSTALL_* variables that are populated by the GNUInstallDirs macro.
23 set(LIB_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}" CACHE PATH "Absolute path to library installation directory")
24 set(EXEC_INSTALL_DIR "${CMAKE_INSTALL_FULL_BINDIR}" CACHE PATH "Absolute path to executable installation directory")
25 set(LIBEXEC_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/webkit2gtk-${WEBKITGTK_API_VERSION}" CACHE PATH "Absolute path to install executables executed by the library")
26
27 set(WEBKITGTK_HEADER_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/webkitgtk-${WEBKITGTK_API_VERSION}")
28 set(INTROSPECTION_INSTALL_GIRDIR "${CMAKE_INSTALL_FULL_DATADIR}/gir-1.0")
29 set(INTROSPECTION_INSTALL_TYPELIBDIR "${LIB_INSTALL_DIR}/girepository-1.0")
30
31 set(USER_AGENT_BRANDING "" CACHE STRING "Branding to add to user agent string")
32 if (USER_AGENT_BRANDING)
33     add_definitions(-DUSER_AGENT_BRANDING="${USER_AGENT_BRANDING}")
34 endif ()
35
36 find_package(Cairo 1.14.0 REQUIRED)
37 find_package(Fontconfig 2.8.0 REQUIRED)
38 find_package(Freetype 2.4.2 REQUIRED)
39 find_package(LibGcrypt 1.6.0 REQUIRED)
40 find_package(GLIB 2.44.0 REQUIRED COMPONENTS gio gio-unix gobject gthread gmodule)
41 find_package(GTK ${GTK_MINIMUM_VERSION} REQUIRED OPTIONAL_COMPONENTS unix-print)
42 find_package(HarfBuzz 0.9.18 REQUIRED COMPONENTS ICU)
43 find_package(ICU 60.2 REQUIRED COMPONENTS data i18n uc)
44 find_package(JPEG REQUIRED)
45 find_package(LibSoup 2.54.0 REQUIRED)
46 find_package(LibXml2 2.8.0 REQUIRED)
47 find_package(PNG REQUIRED)
48 find_package(SQLite3 REQUIRED)
49 find_package(Threads REQUIRED)
50 find_package(ZLIB REQUIRED)
51 find_package(ATK 2.16.0 REQUIRED)
52 find_package(WebP REQUIRED COMPONENTS demux)
53 find_package(ATSPI 2.5.3)
54 find_package(EGL)
55 find_package(OpenGL)
56 find_package(OpenGLES2)
57
58 include(GStreamerDefinitions)
59
60 SET_AND_EXPOSE_TO_BUILD(USE_ATK TRUE)
61 SET_AND_EXPOSE_TO_BUILD(USE_CAIRO TRUE)
62 SET_AND_EXPOSE_TO_BUILD(USE_XDGMIME TRUE)
63 SET_AND_EXPOSE_TO_BUILD(USE_GCRYPT TRUE)
64
65 if (WTF_CPU_ARM OR WTF_CPU_MIPS)
66     SET_AND_EXPOSE_TO_BUILD(USE_CAPSTONE ${DEVELOPER_MODE})
67 endif ()
68
69 # For old versions of HarfBuzz that do not expose an API for the OpenType MATH
70 # table, we enable our own code to parse that table.
71 if ("${PC_HARFBUZZ_VERSION}" VERSION_LESS "1.3.3")
72     add_definitions(-DENABLE_OPENTYPE_MATH=1)
73 endif ()
74
75 # Set the default value for ENABLE_GLES2 automatically.
76 # We are not enabling or disabling automatically a feature here, because
77 # the feature is by default always on (ENABLE_OPENGL=ON).
78 # What we select here automatically is if we use OPENGL (ENABLE_GLES2=OFF)
79 # or OPENGLES2 (ENABLE_GLES2=ON) for building the feature.
80 set(ENABLE_GLES2_DEFAULT OFF)
81
82 if (NOT OPENGL_FOUND AND OPENGLES2_FOUND)
83     set(ENABLE_GLES2_DEFAULT ON)
84 endif ()
85
86 # Public options specific to the GTK port. Do not add any options here unless
87 # there is a strong reason we should support changing the value of the option,
88 # and the option is not relevant to any other WebKit ports.
89 WEBKIT_OPTION_DEFINE(ENABLE_GLES2 "Whether to enable OpenGL ES 2.0." PUBLIC ${ENABLE_GLES2_DEFAULT})
90 WEBKIT_OPTION_DEFINE(ENABLE_GTKDOC "Whether or not to use generate gtkdoc." PUBLIC OFF)
91 WEBKIT_OPTION_DEFINE(ENABLE_INTROSPECTION "Whether to enable GObject introspection." PUBLIC ON)
92 WEBKIT_OPTION_DEFINE(ENABLE_OPENGL "Whether to use OpenGL." PUBLIC ON)
93 WEBKIT_OPTION_DEFINE(ENABLE_QUARTZ_TARGET "Whether to enable support for the Quartz windowing target." PUBLIC ${GTK_SUPPORTS_QUARTZ})
94 WEBKIT_OPTION_DEFINE(ENABLE_X11_TARGET "Whether to enable support for the X11 windowing target." PUBLIC ${GTK_SUPPORTS_X11})
95 WEBKIT_OPTION_DEFINE(ENABLE_WAYLAND_TARGET "Whether to enable support for the Wayland windowing target." PUBLIC ${GTK_SUPPORTS_WAYLAND})
96 WEBKIT_OPTION_DEFINE(USE_LIBNOTIFY "Whether to enable the default web notification implementation." PUBLIC ON)
97 WEBKIT_OPTION_DEFINE(USE_LIBHYPHEN "Whether to enable the default automatic hyphenation implementation." PUBLIC ON)
98 WEBKIT_OPTION_DEFINE(USE_LIBSECRET "Whether to enable the persistent credential storage using libsecret." PUBLIC ON)
99 WEBKIT_OPTION_DEFINE(USE_OPENJPEG "Whether to enable support for JPEG2000 images." PUBLIC ON)
100 WEBKIT_OPTION_DEFINE(USE_WOFF2 "Whether to enable support for WOFF2 Web Fonts." PUBLIC ON)
101 WEBKIT_OPTION_DEFINE(USE_WPE_RENDERER "Whether to enable WPE rendering" PUBLIC ON)
102 WEBKIT_OPTION_DEFINE(USE_SYSTEMD "Whether to enable journald logging" PUBLIC ON)
103
104 # Private options specific to the GTK port. Changing these options is
105 # completely unsupported. They are intended for use only by WebKit developers.
106 WEBKIT_OPTION_DEFINE(USE_ANGLE_WEBGL "Whether to use ANGLE as WebGL backend." PRIVATE OFF)
107
108 # FIXME: Can we use cairo-glesv2 to avoid this conflict?
109 WEBKIT_OPTION_CONFLICT(ENABLE_ACCELERATED_2D_CANVAS ENABLE_GLES2)
110
111 WEBKIT_OPTION_DEPEND(ENABLE_3D_TRANSFORMS ENABLE_OPENGL)
112 WEBKIT_OPTION_DEPEND(ENABLE_ACCELERATED_2D_CANVAS ENABLE_OPENGL)
113 WEBKIT_OPTION_DEPEND(ENABLE_ASYNC_SCROLLING ENABLE_OPENGL)
114 WEBKIT_OPTION_DEPEND(ENABLE_GLES2 ENABLE_OPENGL)
115 WEBKIT_OPTION_DEPEND(ENABLE_WEBGL ENABLE_OPENGL)
116 WEBKIT_OPTION_DEPEND(USE_ANGLE_WEBGL ENABLE_WEBGL)
117 WEBKIT_OPTION_DEPEND(USE_WPE_RENDERER ENABLE_OPENGL)
118 WEBKIT_OPTION_DEPEND(USE_WPE_RENDERER ENABLE_WAYLAND_TARGET)
119
120 SET_AND_EXPOSE_TO_BUILD(ENABLE_DEVELOPER_MODE ${DEVELOPER_MODE})
121 if (DEVELOPER_MODE)
122     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MINIBROWSER PUBLIC ON)
123     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_API_TESTS PRIVATE ON)
124 else ()
125     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MINIBROWSER PUBLIC OFF)
126     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_API_TESTS PRIVATE OFF)
127 endif ()
128
129 if (CMAKE_SYSTEM_NAME MATCHES "Linux")
130     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MEMORY_SAMPLER PRIVATE ON)
131     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_RESOURCE_USAGE PRIVATE ON)
132 else ()
133     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MEMORY_SAMPLER PRIVATE OFF)
134     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_RESOURCE_USAGE PRIVATE OFF)
135 endif ()
136
137 if (CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT EXISTS "/.flatpak-info")
138     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_BUBBLEWRAP_SANDBOX PUBLIC ON)
139 else ()
140     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_BUBBLEWRAP_SANDBOX PUBLIC OFF)
141 endif ()
142
143 # Enable variation fonts when cairo >= 1.16, fontconfig >= 2.13.0, freetype >= 2.9.0 and harfbuzz >= 1.4.2.
144 if (("${PC_CAIRO_VERSION}" VERSION_GREATER "1.16.0" OR "${PC_CAIRO_VERSION}" STREQUAL "1.16.0")
145     AND ("${PC_FONTCONFIG_VERSION}" VERSION_GREATER "2.13.0" OR "${PC_FONTCONFIG_VERSION}" STREQUAL "2.13.0")
146     AND ("${FREETYPE_VERSION_STRING}" VERSION_GREATER "2.9.0" OR "${FREETYPE_VERSION_STRING}" STREQUAL "2.9.0")
147     AND ("${PC_HARFBUZZ_VERSION}" VERSION_GREATER "1.4.2" OR "${PC_HARFBUZZ_VERSION}" STREQUAL "1.4.2"))
148     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_VARIATION_FONTS PRIVATE ON)
149 endif ()
150
151 # Public options shared with other WebKit ports. Do not add any options here
152 # without approval from a GTK reviewer. There must be strong reason to support
153 # changing the value of the option.
154 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_ACCELERATED_2D_CANVAS PUBLIC OFF)
155 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_ASYNC_SCROLLING PRIVATE ON)
156 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DRAG_SUPPORT PUBLIC ON)
157 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SPELLCHECK PUBLIC ON)
158 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_TOUCH_EVENTS PUBLIC ON)
159 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEB_CRYPTO PUBLIC ON)
160 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEBDRIVER PUBLIC ON)
161
162 # Private options shared with other WebKit ports. Add options here when
163 # we need a value different from the default defined in WebKitFeatures.cmake.
164 # Changing these options is completely unsupported.
165 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_AUTOCAPITALIZE PRIVATE ON)
166 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CONTENT_EXTENSIONS PRIVATE ON)
167 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CURSOR_VISIBILITY PRIVATE ON)
168 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DARK_MODE_CSS PRIVATE ON)
169 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DATALIST_ELEMENT PRIVATE ON)
170 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DOWNLOAD_ATTRIBUTE PRIVATE ON)
171 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_ENCRYPTED_MEDIA PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
172 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_FTPDIR PRIVATE OFF)
173 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_INPUT_TYPE_COLOR PRIVATE ON)
174 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_LAYOUT_FORMATTING_CONTEXT PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
175 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MEDIA_STREAM PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
176 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MHTML PRIVATE ON)
177 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MOUSE_CURSOR_SCALE PRIVATE ON)
178 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_NETWORK_CACHE_SPECULATIVE_REVALIDATION PRIVATE ON)
179 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_OFFSCREEN_CANVAS PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
180 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_POINTER_LOCK PRIVATE ON)
181 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SERVICE_WORKER PRIVATE ON)
182 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SHAREABLE_RESOURCE PUBLIC ON)
183 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEB_RTC PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
184 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CSS_PAINTING_API PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
185 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CSS_TYPED_OM PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
186 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CSS_CONIC_GRADIENTS PRIVATE ON)
187 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_RESOURCE_LOAD_STATISTICS PRIVATE ON)
188
189 if (USE_GTK4)
190 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_NETSCAPE_PLUGIN_API PRIVATE OFF)
191 endif ()
192
193 include(GStreamerDependencies)
194
195 # Finalize the value for all options. Do not attempt to use an option before
196 # this point, and do not attempt to change any option after this point.
197 WEBKIT_OPTION_END()
198
199 SET_AND_EXPOSE_TO_BUILD(WTF_PLATFORM_QUARTZ ${ENABLE_QUARTZ_TARGET})
200 SET_AND_EXPOSE_TO_BUILD(WTF_PLATFORM_X11 ${ENABLE_X11_TARGET})
201 SET_AND_EXPOSE_TO_BUILD(WTF_PLATFORM_WAYLAND ${ENABLE_WAYLAND_TARGET})
202
203 if (ENABLE_NETSCAPE_PLUGIN_API)
204     # MOZ_X11 and XP_UNIX are required by npapi.h. Their value is not checked;
205     # only their definedness is. They should only be defined in the true case.
206     if (ENABLE_X11_TARGET)
207         SET_AND_EXPOSE_TO_BUILD(MOZ_X11 1)
208     endif ()
209     SET_AND_EXPOSE_TO_BUILD(XP_UNIX 1)
210 endif ()
211
212 SET_AND_EXPOSE_TO_BUILD(ENABLE_PLUGIN_PROCESS ${ENABLE_NETSCAPE_PLUGIN_API})
213
214 add_definitions(-DBUILDING_GTK__=1)
215 add_definitions(-DGETTEXT_PACKAGE="WebKit2GTK-${WEBKITGTK_API_VERSION}")
216 add_definitions(-DWEBKITGTK_API_VERSION_STRING="${WEBKITGTK_API_VERSION}")
217 add_definitions(-DJSC_GLIB_API_ENABLED)
218
219 if (EXISTS "${TOOLS_DIR}/glib/svn-revision")
220     execute_process(COMMAND ${TOOLS_DIR}/glib/svn-revision ERROR_QUIET OUTPUT_VARIABLE SVN_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE)
221 else ()
222     set(SVN_REVISION "tarball")
223 endif ()
224 add_definitions(-DSVN_REVISION="${SVN_REVISION}")
225
226 SET_AND_EXPOSE_TO_BUILD(HAVE_GTK_UNIX_PRINTING ${GTK_UNIX_PRINT_FOUND})
227
228 if (USE_WPE_RENDERER)
229     find_package(WPE 1.3.0)
230     if (NOT WPE_FOUND)
231         message(FATAL_ERROR "libwpe is required for USE_WPE_RENDERER")
232     endif ()
233
234     find_package(WPEBackend_fdo 1.3.1)
235     if (NOT WPEBACKEND_FDO_FOUND)
236         message(FATAL_ERROR "WPEBackend-fdo is required for USE_WPE_RENDERER")
237     endif ()
238 endif ()
239
240 if (ENABLE_XSLT)
241     find_package(LibXslt 1.1.7 REQUIRED)
242 endif ()
243
244 if (ENABLE_ACCELERATED_2D_CANVAS)
245     if (GLX_FOUND)
246         list(APPEND CAIROGL_COMPONENTS cairo-glx)
247     endif ()
248     if (EGL_FOUND)
249         list(APPEND CAIROGL_COMPONENTS cairo-egl)
250     endif ()
251
252     find_package(CairoGL 1.10.2 COMPONENTS ${CAIROGL_COMPONENTS})
253     if (NOT CAIROGL_FOUND)
254         message(FATAL_ERROR "CairoGL is needed for ENABLE_ACCELERATED_2D_CANVAS")
255     endif ()
256 endif ()
257
258 if (USE_LIBSECRET)
259     find_package(Libsecret)
260     if (NOT LIBSECRET_FOUND)
261         message(FATAL_ERROR "libsecret is needed for USE_LIBSECRET")
262     endif ()
263 endif ()
264
265 if (ENABLE_INTROSPECTION)
266     find_package(GObjectIntrospection)
267     if (NOT INTROSPECTION_FOUND)
268         message(FATAL_ERROR "GObjectIntrospection is needed for ENABLE_INTROSPECTION.")
269     endif ()
270 endif ()
271
272 if (ENABLE_WEB_CRYPTO)
273     find_package(Libtasn1 REQUIRED)
274     if (NOT LIBTASN1_FOUND)
275         message(FATAL_ERROR "libtasn1 is required to enable Web Crypto API support.")
276     endif ()
277     if (LIBGCRYPT_VERSION VERSION_LESS 1.7.0)
278         message(FATAL_ERROR "libgcrypt 1.7.0 is required to enable Web Crypto API support.")
279     endif ()
280 endif ()
281
282 if (ENABLE_WEBDRIVER)
283     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_KEYBOARD_INTERACTIONS ON)
284     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_MOUSE_INTERACTIONS ON)
285     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_TOUCH_INTERACTIONS OFF)
286 endif ()
287
288 SET_AND_EXPOSE_TO_BUILD(USE_TEXTURE_MAPPER TRUE)
289
290 if (ENABLE_OPENGL)
291     # ENABLE_OPENGL is true if either USE_OPENGL or ENABLE_GLES2 is true.
292     # But USE_OPENGL is the opposite of ENABLE_GLES2.
293     if (ENABLE_GLES2)
294         find_package(OpenGLES2 REQUIRED)
295         SET_AND_EXPOSE_TO_BUILD(USE_OPENGL_ES TRUE)
296         SET_AND_EXPOSE_TO_BUILD(USE_OPENGL FALSE)
297
298         if (NOT EGL_FOUND)
299             message(FATAL_ERROR "EGL is needed for ENABLE_GLES2.")
300         endif ()
301     else ()
302         if (NOT OPENGL_FOUND)
303             message(FATAL_ERROR "Either OpenGL or OpenGLES2 is needed for ENABLE_OPENGL.")
304         endif ()
305         SET_AND_EXPOSE_TO_BUILD(USE_OPENGL TRUE)
306     endif ()
307
308     if (NOT EGL_FOUND AND (NOT ENABLE_X11_TARGET OR NOT GLX_FOUND))
309         message(FATAL_ERROR "Either GLX or EGL is needed for ENABLE_OPENGL.")
310     endif ()
311
312     SET_AND_EXPOSE_TO_BUILD(ENABLE_GRAPHICS_CONTEXT_GL TRUE)
313
314     SET_AND_EXPOSE_TO_BUILD(USE_TEXTURE_MAPPER_GL TRUE)
315
316     SET_AND_EXPOSE_TO_BUILD(USE_EGL ${EGL_FOUND})
317
318     if (ENABLE_X11_TARGET AND GLX_FOUND AND USE_OPENGL)
319         SET_AND_EXPOSE_TO_BUILD(USE_GLX TRUE)
320     endif ()
321
322     SET_AND_EXPOSE_TO_BUILD(USE_COORDINATED_GRAPHICS TRUE)
323     SET_AND_EXPOSE_TO_BUILD(USE_NICOSIA TRUE)
324 endif ()
325
326 if (USE_ANGLE_WEBGL)
327     SET_AND_EXPOSE_TO_BUILD(USE_ANGLE TRUE)
328     SET_AND_EXPOSE_TO_BUILD(USE_ANGLE_EGL TRUE)
329 endif ()
330
331 if (ENABLE_SPELLCHECK)
332     find_package(Enchant)
333     if (NOT PC_ENCHANT_FOUND)
334         message(FATAL_ERROR "Enchant is needed for ENABLE_SPELLCHECK")
335     endif ()
336 endif ()
337
338 if (ENABLE_QUARTZ_TARGET)
339     if (NOT GTK_SUPPORTS_QUARTZ)
340         message(FATAL_ERROR "Recompile GTK with Quartz backend to use ENABLE_QUARTZ_TARGET")
341     endif ()
342 endif ()
343
344 if (ENABLE_X11_TARGET)
345     if (NOT GTK_SUPPORTS_X11)
346         message(FATAL_ERROR "Recompile GTK with X11 backend to use ENABLE_X11_TARGET")
347     endif ()
348
349     find_package(X11 REQUIRED)
350     if (NOT X11_Xcomposite_FOUND)
351         message(FATAL_ERROR "libXcomposite is required for ENABLE_X11_TARGET")
352     elseif (NOT X11_Xdamage_FOUND)
353         message(FATAL_ERROR "libXdamage is required for ENABLE_X11_TARGET")
354     elseif (NOT X11_Xrender_FOUND)
355         message(FATAL_ERROR "libXrender is required for ENABLE_X11_TARGET")
356     elseif (NOT X11_Xt_FOUND)
357         message(FATAL_ERROR "libXt is required for ENABLE_X11_TARGET")
358     endif ()
359 endif ()
360
361 if (ENABLE_WAYLAND_TARGET)
362     if (NOT GTK_SUPPORTS_WAYLAND)
363         message(FATAL_ERROR "Recompile GTK with Wayland backend to use ENABLE_WAYLAND_TARGET")
364     endif ()
365
366     if (NOT EGL_FOUND)
367         message(FATAL_ERROR "EGL is required to use ENABLE_WAYLAND_TARGET")
368     endif ()
369
370     find_package(Wayland REQUIRED)
371     find_package(WaylandProtocols 1.12 REQUIRED)
372 endif ()
373
374 if (USE_LIBNOTIFY)
375     find_package(LibNotify)
376     if (NOT LIBNOTIFY_FOUND)
377        message(FATAL_ERROR "libnotify is needed for USE_LIBNOTIFY.")
378     endif ()
379 endif ()
380
381 if (USE_LIBHYPHEN)
382     find_package(Hyphen)
383     if (NOT HYPHEN_FOUND)
384        message(FATAL_ERROR "libhyphen is needed for USE_LIBHYPHEN.")
385     endif ()
386 endif ()
387
388 if (USE_OPENJPEG)
389     find_package(OpenJPEG 2.2.0)
390     if (NOT OpenJPEG_FOUND)
391         message(FATAL_ERROR "libopenjpeg 2.2.0 is required for USE_OPENJPEG.")
392     endif ()
393 endif ()
394
395 if (USE_WOFF2)
396     find_package(WOFF2Dec 1.0.2)
397     if (NOT WOFF2DEC_FOUND)
398        message(FATAL_ERROR "libwoff2dec is needed for USE_WOFF2.")
399     endif ()
400 endif ()
401
402 if (USE_SYSTEMD)
403     find_package(Systemd)
404     if (Systemd_FOUND)
405         message(STATUS "Release logs will be sent to the Systemd journal")
406         SET_AND_EXPOSE_TO_BUILD(USE_JOURNALD TRUE)
407     else ()
408         message(FATAL_ERROR "libsystemd is needed for USE_SYSTEMD")
409     endif ()
410 endif ()
411
412 # https://bugs.webkit.org/show_bug.cgi?id=182247
413 if (ENABLED_COMPILER_SANITIZERS)
414     set(ENABLE_INTROSPECTION OFF)
415 endif ()
416
417 # Override the cached variables, gtk-doc and gobject-introspection do not really work when cross-building.
418 if (CMAKE_CROSSCOMPILING)
419     set(ENABLE_GTKDOC OFF)
420     set(ENABLE_INTROSPECTION OFF)
421 endif ()
422
423 # Override the cached variable, gtk-doc does not really work when building on Mac.
424 if (APPLE)
425     set(ENABLE_GTKDOC OFF)
426 endif ()
427
428 set(DERIVED_SOURCES_WEBKITGTK_DIR ${DERIVED_SOURCES_DIR}/webkitgtk)
429 set(DERIVED_SOURCES_WEBKITGTK_API_DIR ${DERIVED_SOURCES_WEBKITGTK_DIR}/webkit)
430 set(DERIVED_SOURCES_WEBKIT2GTK_DIR ${DERIVED_SOURCES_DIR}/webkit2gtk)
431 set(DERIVED_SOURCES_WEBKIT2GTK_API_DIR ${DERIVED_SOURCES_WEBKIT2GTK_DIR}/webkit2)
432 set(DERIVED_SOURCES_JAVASCRIPCOREGTK_DIR ${DERIVED_SOURCES_JAVASCRIPTCORE_DIR}/javascriptcoregtk)
433 set(DERIVED_SOURCES_JAVASCRIPCORE_GLIB_API_DIR ${DERIVED_SOURCES_JAVASCRIPTCORE_DIR}/javascriptcoregtk/jsc)
434 set(FORWARDING_HEADERS_WEBKIT2GTK_DIR ${FORWARDING_HEADERS_DIR}/webkit2gtk)
435 set(FORWARDING_HEADERS_WEBKIT2GTK_EXTENSION_DIR ${FORWARDING_HEADERS_DIR}/webkit2gtk-webextension)
436
437 set(JavaScriptCore_PKGCONFIG_FILE ${CMAKE_BINARY_DIR}/Source/JavaScriptCore/javascriptcoregtk-${WEBKITGTK_API_VERSION}.pc)
438 set(WebKit2_PKGCONFIG_FILE ${CMAKE_BINARY_DIR}/Source/WebKit/webkit2gtk-${WEBKITGTK_API_VERSION}.pc)
439 set(WebKit2WebExtension_PKGCONFIG_FILE ${CMAKE_BINARY_DIR}/Source/WebKit/webkit2gtk-web-extension-${WEBKITGTK_API_VERSION}.pc)
440
441 set(JavaScriptCore_LIBRARY_TYPE SHARED)
442 set(SHOULD_INSTALL_JS_SHELL ON)
443
444 # Add a typelib file to the list of all typelib dependencies. This makes it easy to
445 # expose a 'gir' target with all gobject-introspection files.
446 macro(ADD_TYPELIB typelib)
447     if (ENABLE_INTROSPECTION)
448         get_filename_component(target_name ${typelib} NAME_WE)
449         add_custom_target(${target_name}-gir ALL DEPENDS ${typelib})
450         list(APPEND GObjectIntrospectionTargets ${target_name}-gir)
451         set(GObjectIntrospectionTargets ${GObjectIntrospectionTargets} PARENT_SCOPE)
452     endif ()
453 endmacro()
454
455 # CMake does not automatically add --whole-archive when building shared objects from
456 # a list of convenience libraries. This can lead to missing symbols in the final output.
457 # We add --whole-archive to all libraries manually to prevent the linker from trimming
458 # symbols that we actually need later. With ld64 on darwin, we use -all_load instead.
459 macro(ADD_WHOLE_ARCHIVE_TO_LIBRARIES _list_name)
460     if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
461         list(APPEND ${_list_name} -Wl,-all_load)
462     else ()
463         set(_tmp)
464         foreach (item IN LISTS ${_list_name})
465             if ("${item}" STREQUAL "PRIVATE" OR "${item}" STREQUAL "PUBLIC")
466                 list(APPEND _tmp "${item}")
467             else ()
468                 list(APPEND _tmp -Wl,--whole-archive "${item}" -Wl,--no-whole-archive)
469             endif ()
470         endforeach ()
471         set(${_list_name} ${_tmp})
472     endif ()
473 endmacro()
474
475 include(BubblewrapSandboxChecks)
476 include(GStreamerChecks)